<?php
/**
 * Faboba News System 
 * Joomla! 1.5 component fanews
 * @author	Stphane Bouey {@link http://www.faboba.com}
 * @package Joomla
 * @subpackage Fanews
 * @license GNU/GPL
 * @Copyright (C) 2010 Faboba.com
 */

// no direct access
defined('_JEXEC') or die('Restricted access');

jimport( 'joomla.application.component.controller' );
require_once( JPATH_COMPONENT.DS.'helpers'.DS.'helper.php' );

/**
 * fanews Controller
 *
 * @package Joomla
 * @subpackage fanews
 */
class FanewsController extends JController {
/**
 * constructor (registers additional tasks to methods)
 * @return void
 */
    function __construct() {
        parent::__construct();

        // Register Extra tasks
        $this->registerTask( 'add'  , 	'edit' );
        $this->registerTask( 'unpublish' , 'publish');
    }

    ## This function will display if there is no choice.
    function display() {

        JRequest::setVar( 'layout', 'default');
        JRequest::setVar( 'view', 'news');
        parent::display();
    }


    /**
     * display the edit form
     * @return void
     */
    function edit() {
        JRequest::setVar( 'layout', 'form'  );
        JRequest::setVar( 'view', 'news' );
        JRequest::setVar('hidemainmenu', 1);

        parent::display();
    }

    /**
     * save a record (and redirect to main page)
     * @return void
     */
    function save() {
        $model = $this->getModel('news');

        if ($model->store()) {
            $msg = JText::_( 'News Saved!' );
        } else {
            $msg = JText::_( 'Error Saving News' );
        }

        // Check the table in so it can be edited.... we are done with it anyway
        $link = 'index.php?option=com_fanews';
        $this->setRedirect($link, $msg);
    }

    /**
     * remove record(s)
     * @return void
     */
    function remove() {
        $model = $this->getModel('news');
        if(!$model->delete()) {
            $msg = JText::_( 'Error: One or More News Could not be Deleted' );
        } else {
            $msg = JText::_( 'News(s) Deleted' );
        }

        $this->setRedirect( 'index.php?option=com_fanews', $msg );
    }

    /**
     * cancel editing a record
     * @return void
     */
    function cancel() {
        $msg = JText::_( 'Operation Cancelled' );
        $this->setRedirect( 'index.php?option=com_fanews', $msg );
    }

    function publish() {
        // Check for request forgeries
        //JRequest::checkToken() or jexit( 'Invalid Token' );
        $db		=& JFactory::getDBO();
        $user	=& JFactory::getUser();
        $cid     = JRequest::getVar( 'cid', array(0), 'post', 'array' );
        JArrayHelper::toInteger($cid, array(0));
        $publish = ( $this->getTask() == 'publish' ? 1 : 0 );

        if (count( $cid ) < 1) {
            $action = $publish ? JText::_( 'publish' ) : JText::_( 'unpublish' );
            JError::raiseError(500, JText::_( 'Select a news to '.$action ) );
        }

        $cids = implode( ',', $cid );

        $query = 'UPDATE #__fanews SET published = '.(int) $publish
            . ' WHERE id IN ( '.$cids.' )'
        ;
        $db->setQuery( $query );
        if (!$db->query()) {
            JError::raiseError(500, $db->getErrorMsg() );
        }

        if (count( $cid ) == 1) {
            $row =& JTable::getInstance('plugin');
            $row->checkin( $cid[0] );
        }

        $this->setRedirect( 'index.php?option=com_fanews','published');
    }
}
?>