<?php
/**
* Faboba News System 
* @package Joomla!
* @Copyright (C) 2010 Faboba.com
* @ All rights reserved
* @ Joomla! is Free Software
* @ Released under GNU/GPL License : http://www.gnu.org/copyleft/gpl.html
* @version $Revision: 1.0 $
**/

// no direct access
defined('_JEXEC') or die('Restricted access');
// import com_content route helper
require_once (JPATH_SITE.DS.'components'.DS.'com_content'.DS.'helpers'.DS.'route.php');
// import JString class for UTF-8 problems
jimport('joomla.utilities.string'); 
// Main class
class FaNewsHelper
{
	var $config;
	var $content;
	
	/**
	 *	INITIALIZATION
	 **/
	
	function init()
	{		
		$this->config = array(
			'module_unique_id' => '',
			'width_module' => 0,
			'height_module' => 0,
			'width_links' => 0,
			'left_padding' => 0,
                        'right_padding' => 0,
			'mode' => 0,
			'max_news' => 0,
			'news_sort_value' => 0,
			'news_sort_order' => 0,
            	        'interface_style' => 1,
                        'news_title_pos' => 1,
                        'news_text_pos' => 1,
			'autoanim' => 0,
			'hover_anim' => 0,
			'animation_speed' => 0,
			'animation_interval' => 0,
			// Advanced params
			'parse_plugins' => 0,
			'clean_plugins' => 0,	
			'use_css' => 1,
			'use_moo' => 0,
			'use_script' => 0,
			'compress_js' => 0
		);	
	}
	
	/**
	 * 
	 *	VARIABLES VALIDATION
	 * 
	 **/
	
	function validateVariables(&$params)
	{
		$this->config['module_unique_id'] = $params->get('module_unique_id','fanews1'); // unique ID
		$this->config['width_module'] = $params->get('width_module', 0); // main content width
		$this->config['height_module'] = $params->get('height_module', 0); // main content width
		$this->config['left_padding'] = $params->get('left_padding', 0); // news left padding
                $this->config['right_padding'] = $params->get('right_padding', 0); // news left padding
                $this->config['max_news'] = $params->get('max_news', 10); // max. amount of news to display 
                $this->config['news_sort_value'] = $params->get('news_sort_value','created'); // Parameter for SQL Query - value of sort
                $this->config['news_sort_order'] = $params->get('news_sort_order','DESC'); // Parameter for SQL Query - sort direct
                $this->config['interface_style'] = $params->get('interface_style', 1); // style d'interface
                $this->config['news_title_pos'] = $params->get('news_title_pos', 1); // style d'interface
                $this->config['news_text_pos'] = $params->get('news_text_pos', 1); // style d'interface
                $this->config['autoanim'] = (bool) $params->get('autoanim', 0); // autoanimation enabled ?
		$this->config['hover_anim'] = (bool) $params->get('hover_anim', 0); // hover animation enabled ?
		$this->config['animation_speed'] = $params->get('animation_speed', 500);
		$this->config['animation_interval'] = $params->get('animation_interval', 5000);
		//advanced
		$this->config['use_css'] = $params->get('use_css', 1);
		$this->config['use_moo'] = $params->get('use_moo', 2); // add mootools script to page (if you use more than one module per page then disable it / or if you have mootools included)
		$this->config['use_script'] = $params->get('use_script', 2); // add script for this module to page (if you use more than one module per page then disable it)
		$this->config['compress_js'] = $params->get('compress_js', 1);
		//
	}
	
	/**
	 * 
	 *	GETTING DATA
	 * 
	 **/
		
	function getDatas()
	{
		//
		$db =& JFactory::getDBO();
		// Getting list of categories
                $this->content = $this->getNews($this->config);
	}

        function getNews($config) {
        // mainframe
            global $mainframe;
            // Arrays for content
            $content_id = array();
            $content_title = array();
            $content_fulltext = array();
            $news_amount = 0;
            // Initializing standard Joomla classes and SQL necessary variables
            $db =& JFactory::getDBO();
            $news=null;

            // Ordering string
            $order_options = '';
            // When sort value is random
            if($config['news_sort_value'] == 'random') {
                $order_options = ' RAND() ';
            }
            else // when sort value is different than random
            {
               $order_options = 'f.'.$config['news_sort_value'].' '.$config['news_sort_order'].' ';
            }

            $query_name = 'SELECT DISTINCT f.id AS ID, f.title AS TITLE, f.fulltext AS FTEXT'.
			   ' FROM #__fanews AS f'.
			   ' WHERE f.published = 1'.
                           ' ORDER BY '.$order_options.
			   ' LIMIT '.($config['max_news']);

            // Executing SQL Query
            $db->setQuery($query_name);
            $news = $db->loadObjectList();
            if($news) {
            // generating tables of news data
                foreach($news as $item) {
                    $content_id[] = $item->ID; // news IDs
                    $content_title[] = $item->TITLE; // news titles
                    $content_fulltext[] = $item->FTEXT; // news text
                    $news_amount++;	// news amount
            }//foreach
            }
            //
            // Returning data in hash table
            //

            return array(
            "ID" => $content_id,
            "title" => $content_title,
            "text" => $content_fulltext,
            "news_amount" => $news_amount
            );
        }
        
	/**
	 * 
	 *	RENDERING LAYOUT
	 * 
	 **/
	
	function renderLayout()
	{	
		$renderer = new FaNewsLayout();
		// tables which will be used in generated content
		$news_list_tab = array();
		//
		$news_html_tab = array();
		// Generating content 
		$uri =& JURI::getInstance();
			
                //
                $li_counter = 0;
                //
                for($i = 0; $i < count($this->content["ID"]); $i++)
                {
                    //
                    if($i < ($this->config['max_news']))
                    {
                            /* GENERATING NEWS CONTENT */
                            // GENERATING TITLE
                            $news_header = $renderer->returnTitle($this->config, $this->content['ID'][$i], $this->content['title'][$i]);
                            // GENERATING TEXT
                            $news_textt = $renderer->returnText($this->config, $this->content['ID'][$i], $this->content['text'][$i]);
                            // GENERATE CONTENT FOR TAB
                            $news_generated_content = ''; // initialize variable
                            $news_generated_content .= $news_header;
                            $news_generated_content .= $news_textt;
                            //
                            // creating table with news content
                            $news_html_tab[] = $news_generated_content;
                    }
                }
		
		// create instances of basic Joomla! classes
		$document =& JFactory::getDocument();
		$uri =& JURI::getInstance();
		// add stylesheets to document header
		if($this->config["use_css"] == 1){
			$document->addStyleSheet( $uri->root().'modules/mod_fanews/style/style.css', 'text/css' );
		}
		// init $headData variable
		$headData = false;
		// add scripts with automatic mode to document header
		if($this->config['use_moo'] == 2)
		{
			// getting module head section datas
			unset($headData);
			$headData = $document->getHeadData();
			// generate keys of script section
			$headData_keys = array_keys($headData["scripts"]);
			// set variable for false
			$mootools_founded = false;
			// searching phrase mootools in scripts paths
			for($i = 0;$i < count($headData_keys); $i++)
			{
				if(preg_match('/mootools/i', $headData_keys[$i]))
				{
					// if founded set variable to true and break loop
					$mootools_founded = true;
					break;
				}
			}
			// if mootools file doesn't exists in document head section
			if(!$mootools_founded)
			{
				// add new script tag connected with mootools from module
				$headData["scripts"][$uri->root().'modules/mod_fanews/scripts/mootools.js'] = "text/javascript";
				// if added mootools from module then this operation have sense
				$document->setHeadData($headData);
			}
		}
		
		if($this->config['use_script'] == 2)
		{
			// getting module head section datas
			unset($headData);
			$headData = $document->getHeadData();
			// generate keys of script section
			$headData_keys = array_keys($headData["scripts"]);
			// set variable for false
			$engine_founded = false;
			// searching phrase mootools in scripts paths
			if(array_search($uri->root().'modules/mod_fanews/scripts/engine'.(($this->config['compress_js'] == 1) ? '_compressed' : '').'.js', $headData_keys) > 0)
			{
				// if founded set variable to true
				$engine_founded = true;
			}
			// if mootools file doesn't exists in document head section
			if(!$engine_founded)
			{
				// add new script tag connected with mootools from module
				$headData["scripts"][$uri->root().'modules/mod_fanews/scripts/engine'.(($this->config['compress_js'] == 1) ? '_compressed' : '').'.js'] = "text/javascript";
				// if added mootools from module then this operation have sense
				$document->setHeadData($headData);
			}
		}
		//
		require(JModuleHelper::getLayoutPath('mod_fanews', 'view.default'));
		require(JModuleHelper::getLayoutPath('mod_fanews', 'view.script_style'));
	}
	
}

?>